<?php

namespace fk_\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKSubeBiyografisi ArrayType
 * @subpackage Arrays
 */
class ArrayOfKSubeBiyografisi extends AbstractStructArrayBase
{
    /**
     * The KSubeBiyografisi
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \fk_\StructType\KSubeBiyografisi[]
     */
    public $KSubeBiyografisi;
    /**
     * Constructor method for ArrayOfKSubeBiyografisi
     * @uses ArrayOfKSubeBiyografisi::setKSubeBiyografisi()
     * @param \fk_\StructType\KSubeBiyografisi[] $kSubeBiyografisi
     */
    public function __construct(array $kSubeBiyografisi = array())
    {
        $this
            ->setKSubeBiyografisi($kSubeBiyografisi);
    }
    /**
     * Get KSubeBiyografisi value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \fk_\StructType\KSubeBiyografisi[]|null
     */
    public function getKSubeBiyografisi()
    {
        return isset($this->KSubeBiyografisi) ? $this->KSubeBiyografisi : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKSubeBiyografisi method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKSubeBiyografisi method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKSubeBiyografisiForArrayConstraintsFromSetKSubeBiyografisi(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKSubeBiyografisiKSubeBiyografisiItem) {
            // validation for constraint: itemType
            if (!$arrayOfKSubeBiyografisiKSubeBiyografisiItem instanceof \fk_\StructType\KSubeBiyografisi) {
                $invalidValues[] = is_object($arrayOfKSubeBiyografisiKSubeBiyografisiItem) ? get_class($arrayOfKSubeBiyografisiKSubeBiyografisiItem) : sprintf('%s(%s)', gettype($arrayOfKSubeBiyografisiKSubeBiyografisiItem), var_export($arrayOfKSubeBiyografisiKSubeBiyografisiItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KSubeBiyografisi property can only contain items of type \fk_\StructType\KSubeBiyografisi, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KSubeBiyografisi value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\KSubeBiyografisi[] $kSubeBiyografisi
     * @return \fk_\ArrayType\ArrayOfKSubeBiyografisi
     */
    public function setKSubeBiyografisi(array $kSubeBiyografisi = array())
    {
        // validation for constraint: array
        if ('' !== ($kSubeBiyografisiArrayErrorMessage = self::validateKSubeBiyografisiForArrayConstraintsFromSetKSubeBiyografisi($kSubeBiyografisi))) {
            throw new \InvalidArgumentException($kSubeBiyografisiArrayErrorMessage, __LINE__);
        }
        if (is_null($kSubeBiyografisi) || (is_array($kSubeBiyografisi) && empty($kSubeBiyografisi))) {
            unset($this->KSubeBiyografisi);
        } else {
            $this->KSubeBiyografisi = $kSubeBiyografisi;
        }
        return $this;
    }
    /**
     * Add item to KSubeBiyografisi value
     * @throws \InvalidArgumentException
     * @param \fk_\StructType\KSubeBiyografisi $item
     * @return \fk_\ArrayType\ArrayOfKSubeBiyografisi
     */
    public function addToKSubeBiyografisi(\fk_\StructType\KSubeBiyografisi $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \fk_\StructType\KSubeBiyografisi) {
            throw new \InvalidArgumentException(sprintf('The KSubeBiyografisi property can only contain items of type \fk_\StructType\KSubeBiyografisi, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KSubeBiyografisi[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \fk_\StructType\KSubeBiyografisi|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \fk_\StructType\KSubeBiyografisi|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \fk_\StructType\KSubeBiyografisi|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \fk_\StructType\KSubeBiyografisi|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \fk_\StructType\KSubeBiyografisi|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KSubeBiyografisi
     */
    public function getAttributeName()
    {
        return 'KSubeBiyografisi';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\ArrayType\ArrayOfKSubeBiyografisi
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
